WINAPI: SetBkMode gdi32.dll
WINAPI: SetTextColor gdi32.dll
WINAPI: SetBkColor gdi32.dll
WINAPI: CreateSolidBrush gdi32.dll
WINAPI: InvalidateRect user32.dll
WINAPI: GetSysColor USER32.DLL
WINAPI: GetSysColorBrush USER32.DLL

Window REOPEN
    var vTextColor
    var vTextBkColor
    var vBkColor
    var vColored

M: Set-colors { c }
    lparam @ HANDLE>OBJ ?DUP \      ?
IF
    DUP => vColored @
    IF
        DUP => vTextColor @ TRANSPARENT =
        IF
            TRANSPARENT wparam @ SetBkMode DROP
        THEN
        DUP => vTextColor @ wparam @ SetTextColor DROP
        DUP => vTextBkColor @ wparam @ SetBkColor DROP
        => vBkColor @

    ELSE
        DROP
        c
        CASE
            1 OF COLOR_WINDOWTEXT GetSysColor wparam @ SetTextColor DROP
                COLOR_WINDOW GetSysColor wparam @ SetBkColor DROP

              ENDOF
          DUP OF COLOR_WINDOWTEXT GetSysColor wparam @ SetTextColor DROP
                COLOR_WINDOW GetSysColor wparam @ SetBkColor DROP
                COLOR_WINDOW GetSysColorBrush
              ENDOF
        ENDCASE
    THEN
ELSE
\         (     )?
    GWL_HWNDPARENT lparam @ GetWindowLongA
    HANDLE>OBJ ?DUP \   "",    
    IF
        DUP => vColored @
        IF
            DUP => vTextColor @ TRANSPARENT =
            IF
                TRANSPARENT wparam @ SetBkMode DROP
            THEN
            DUP => vTextColor @ wparam @ SetTextColor DROP
            DUP => vTextBkColor @ wparam @ SetBkColor DROP
            => vBkColor @
        THEN
    THEN

THEN
;

W: WM_CTLCOLORSTATIC
    1 Set-colors
;

W: WM_CTLCOLOREDIT
    2 Set-colors
;

W: WM_CTLCOLORBTN
    3 Set-colors
;

W: WM_CTLCOLORLISTBOX
    4 Set-colors
;

W: WM_CTLCOLORMSGBOX
    5 Set-colors
;
W: WM_CTLCOLORSCROLLBAR
    6 Set-colors
;
W: WM_CTLCOLORDLG
    7 Set-colors
;

M: ColorOFF \    
    0 vColored !
    TRUE 0 handle @ InvalidateRect DROP
;

M: del-bk
    vColored @ IF vBkColor @ DeleteObject DROP THEN
;

M: cre-bk
    vColored @ IF  vBkColor @ DUP vTextBkColor ! CreateSolidBrush vBkColor ! THEN
;

M: Set-color ( text bk -- ) \    
    -1 vColored !
    del-bk
    vBkColor !
    cre-bk
\    DROP
    vTextColor !
    TRUE 0 handle @ InvalidateRect DROP
;

DESTR: free
    del-bk
    free
;
M: Create
    Create
    cre-bk
;

;CLASS


CLASS: FrameWindow <SUPER Window

 /MSG FIELD    vMSG    \    
      var vClose
      var vModalResult
      var vHeap
      var vPopupMenu
      var vFont
      var vClass

      var vAutoList     \ list of controls

      var vAccel

      var onKeyDown
      var onKeyUp
      var onExit

CONSTR: init
    init
    WS_CAPTION  WS_SYSMENU OR ( WS_THICKFRAME OR) WS_MINIMIZEBOX OR
    ( WS_MAXIMIZEBOX OR)  WS_POPUP OR vStyle !
    WS_EX_CONTROLPARENT vExStyle !
    THREAD-HEAP @ TO MAIN-HEAP
    DefWinClass SELF vClass !
;

M: AddAuto ( obj -- ) vAutoList AppendNode ;

M: BringToTop   handle @ BringWindowToTop DROP ;

M: ShowMessage ( addr u -- )
    DROP >R MB_OK MB_ICONINFORMATION OR GetText DROP R> handle @
    MessageBoxA DROP ;

M: TranslateAccel
    vAccel @
    IF vMSG vAccel @ handle @ TranslateAcceleratorA

    ELSE
        0
    THEN
;

: ?ProcessKey ( n a -- )
    @ ?DUP
    IF
        SWAP vMSG MSG.uint @ =
        IF
            vMSG MSG.wparam @ wparam !
            vMSG MSG.lparam @ lparam !
            EXECUTE RDROP
        ELSE DROP THEN
    ELSE DROP THEN
;

M: ProcessKey ( -- ?)
    WM_KEYDOWN onKeyDown ?ProcessKey
    WM_KEYUP onKeyUp ?ProcessKey
    FALSE
;

M: ProcessMessage ( -- bool )
  PM_REMOVE 0 0 0 vMSG PeekMessageA DUP
  IF
    vMSG MSG.uint @ WM_QUIT <>
    IF
       ProcessKey 0=
       IF
           vMSG handle @ IsDialogMessage 0=
           IF
              vMSG TranslateMessage DROP
              vMSG DispatchMessageA DROP
           THEN
        THEN
    ELSE
       TRUE vClose !
       vModalResult 0!
    THEN
  THEN
;

M: ProcessMessages ( -- )
  BEGIN
    ProcessMessage 0=
  UNTIL
;

\ idle    INHERIT,    
M: Idle ( -- )   WaitMessage DROP ;

M: HandleMessage ( -- )
   ProcessMessage 0=
   IF
     vClose @ 0= IF Idle THEN
   THEN
;

M: Run ( -- )
   BEGIN
     HandleMessage
     vClose @
   UNTIL
;


W: WM_NOTIFY
    lparam @ 2 CELLS + @     \ DUP HEX U. DECIMAL
    lparam @ @               \ HEX DUP U. DECIMAL

    HANDLE>OBJ               \ DUP . CR
    >R
    R@ IF lparam @ 0 0 handle @ R@ => FillMessage THEN
    R> [CHAR] N ->WM
;


VM: OnPaint  ;


W: WM_PAINT
   32 RALLOT DUP
   handle @ BeginPaint TO dc
   SP@ >R
   OnPaint
   R> SP!
   handle @ EndPaint DROP
   32 _RFREE
   0
;


W: WM_COMMAND
     lparam @ 0= wparam @ DUP 0<> SWAP HIWORD 0= AND OR
     IF \ 
       handle @ GetMenu 0<>
       IF \  
         wparam @ LOWORD ?DUP
         IF \      
            this [CHAR] M ->WM
         THEN
       THEN
     ELSE \ 
       wparam @ HIWORD
       lparam @ HANDLE>OBJ
       [CHAR] C ->WM
     THEN
     0
;


W: WM_NCCREATE
   TRUE
;

VM: OnExit ;

W: WM_CLOSE
   OnExit
   handle @ GetParent DUP IsWindow
   IF TRUE SWAP EnableWindow DROP ELSE DROP THEN \   ShowModal  
   Hide
   TRUE vClose !
   0
;

VM: CreatePopup ( -- h) 0 ;

M: TrackPopup { x y h -- }
   h 0= IF EXIT THEN
   0 handle @ 0 x y
   TPM_NONOTIFY TPM_RETURNCMD OR
   h TrackPopupMenu this [CHAR] M ->WM
;

VM: GetPopupMenu vPopupMenu @ ;

W: WM_CONTEXTMENU
   lparam @ LOWORD
   lparam @ HIWORD SWAP
   GetPopupMenu TrackPopup
   0
;

VM: Type vClass @ ->CLASS WinClass Register 0 ;


M: Create { owner -- }
    Font NEW vFont !
    14 vFont @ ->CLASS Font height !
    COLOR_BTNFACE GetSysColorBrush vClass @ ->CLASS WinClass hbrBackground !
    vFont @ ->CLASS Font Create
    owner Create
    CreatePopup vPopupMenu !
;

\  64   

M: ShowModal { \ stack aw -- u }
GLOBAL
    GetActiveWindow TO aw
    Show
    Stack NEW TO stack
    stack DisableTaskWindows \       
    TRUE handle @ EnableWindow DROP
    Run
    stack EnableTaskWindows \   
    stack DELETE
    hParent @ ?DUP 0= IF aw THEN SetActiveWindow DROP
    vModalResult @
LOCAL
;

M: ModalResult! ( u -- )
     vModalResult !
     Hide
     TRUE vClose !
;

M: SetMenu ( menu -- )  handle @ SetMenu DROP ;


DESTR: free
    vMenu @ IsMenu IF vMenu @ DestroyMenu DROP THEN
    vAccel @ ?DUP IF DestroyAcceleratorTable DROP THEN
    free
;
: obj! { h obj -- }
\  self  GWL_USERDATA
    h obj => handle !
    obj GWL_USERDATA h SetWindowLongA DROP
;

: h. BASE @ >R HEX . R> BASE ! ;


:NONAME { lparam wparam uint hwnd \ heap dep -- }
     DEPTH  TO dep
     THREAD-HEAP @ TO heap
     MAIN-HEAP THREAD-HEAP !

     hwnd HANDLE>OBJ
     ?DUP 0=
     IF
       uint WM_NCCREATE =
       IF
         lparam @ hwnd OVER obj!
         lparam wparam uint hwnd lparam @ => FillMessage
         WM_NCCREATE SWAP WM:
       ELSE
         lparam wparam uint hwnd  DefWindowProcA
       THEN
     ELSE \    
       uint OVER [CHAR] W SearchWM
       IF
           lparam wparam uint hwnd DUP HANDLE>OBJ => FillMessage
           SWAP ExecuteMethod
       ELSE
         DROP
         lparam wparam uint hwnd DefWindowProcA
       THEN
     THEN
     heap THREAD-HEAP !
     DEPTH dep - 0= IF 0 THEN
;

\ WNDPROC: (WIN-GATE)
QWNDPROC: (WIN-GATE)
 ' (WIN-GATE) TO WIN-GATE

;CLASS
